/*
 * @(#)CpeProcessTreePanel.java	1.0 98/1/5
 */

import javax.swing.*;
import javax.swing.text.*;
import javax.swing.tree.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

import Cpe;

/**
 * The tree panel acts as a tree-like browser and organizer of the 
 * process windows in the CpeMainPanel.
 *
 * This has been dropped from 1.0.
 *
 * @version 1.0 98/1/5
 * @author Steve Polyak
 */
public class CpeProcessTreePanel extends JPanel 
{
  Cpe cpe;

  public CpeProcessTreePanel(Cpe cpe) {
    this.cpe = cpe;
    setLayout(new BorderLayout());
    
    DefaultMutableTreeNode top = new DefaultMutableTreeNode("Process 1     ");
    DefaultMutableTreeNode issues1;
    DefaultMutableTreeNode nodes1;
    DefaultMutableTreeNode orderings1;
    DefaultMutableTreeNode vars1;
    DefaultMutableTreeNode aux1;
    
    issues1 = new DefaultMutableTreeNode("Issues     ");
    nodes1 = new DefaultMutableTreeNode("Node Constraints     ");
    orderings1 = new DefaultMutableTreeNode("Ordering Constraints     ");
    vars1 = new DefaultMutableTreeNode("Variable Constraints     ");
    aux1 = new DefaultMutableTreeNode("Auxiliary Constraints     ");
    DefaultMutableTreeNode empty1 = new 
      DefaultMutableTreeNode("*None*     ");
    DefaultMutableTreeNode empty2 = new 
      DefaultMutableTreeNode("*None*     ");
    DefaultMutableTreeNode empty3 = new 
      DefaultMutableTreeNode("*None*     ");
    
    top.add(issues1);
    issues1.add(empty1);
    
    top.add(nodes1);
    DefaultMutableTreeNode node1_1 = new 
      DefaultMutableTreeNode("Start     ");
    nodes1.add(node1_1);
    DefaultMutableTreeNode node1_2 = new 
      DefaultMutableTreeNode("Finish     ");
    nodes1.add(node1_2);

    top.add(orderings1);
    DefaultMutableTreeNode order1_1 = new 
      DefaultMutableTreeNode("Before(End(start),Begin(finish))     ");
    orderings1.add(order1_1);
    
    top.add(vars1);
    vars1.add(empty2);
    
    top.add(aux1);
    aux1.add(empty3);
    
    JTree tree = new JTree(top);
    add(new JScrollPane(tree), BorderLayout.CENTER);
  }
}
